package dep

import (
	"kpt-tmr-group/config"
	"kpt-tmr-group/module/backend"
	"kpt-tmr-group/pkg/di"
	"kpt-tmr-group/service/sso"
	"kpt-tmr-group/service/wechat"
	"kpt-tmr-group/store/kptstore"
)

// Global 全局所有的依赖
// 除了:
// * cmd
// * http
// * grpc
func Global() di.HubOption {
	return di.Options(Options()...)
}

func Options() []di.HubOption {
	return []di.HubOption{
		// 基础依赖
		config.Module,
		// store
		kptstore.Module,
		backend.Module,
		sso.Module,
		wechat.Module,
	}
}
