package route

import (
	"kpt-tmr-group/http/debug"
	"kpt-tmr-group/http/handler"

	"github.com/gin-gonic/gin"
)

func DebugAPI(opts ...func(engine *gin.Engine)) func(s *gin.Engine) {
	return func(s *gin.Engine) {
		for _, opt := range opts {
			opt(s)
		}

		// Not Found
		s.NoRoute(handler.Handle404)
		s.GET("/debug/test", debug.HelloOk)
		debugRoute := authRouteGroup(s, "/api/v1/kpt/debug/")
		// kpt debug api
		debugRoute.GET("hello", debug.HelloOk)
		debugRoute.POST("pasture/feed_formula/sync", debug.FeedFormulaSync)                       // 同步牧场端饲料配方
		debugRoute.POST("pasture/feed/sync", debug.FeedSync)                                      // 同步牧场端饲料
		debugRoute.POST("pasture/feed_formula/detail_list/sync", debug.FeedFormulaDetailListSync) // 同步牧场端饲料配方详情
	}

}
