package model

import operationPb "kpt-tmr-group/proto/go/backend/operation"

type FeedFormulaEditRecord struct {
	Id            int64                                      `json:"id"`
	GroupId       int64                                      `json:"group_id"`
	FeedFormulaId int64                                      `json:"feed_formula_id"`
	PastureId     int64                                      `json:"pasture_id"`
	PastureName   string                                     `json:"pasture_name"`
	OperationName string                                     `json:"operation_name"`
	ForageName    string                                     `json:"forage_name"`
	FieldName     string                                     `json:"field_name"`
	Status        operationPb.FeedFormulaEditRecordType_Kind `json:"status"`
	BeforeValue   string                                     `json:"before_value"`
	AfterValue    string                                     `json:"after_value"`
	CreatedAt     int64                                      `json:"created_at"`
	UpdatedAt     int64                                      `json:"updated_at"`
}

func (f *FeedFormulaEditRecord) TableName() string {
	return "feed_formula_edit_record"
}

func NewFeedFormulaEditRecord(groupId, feedFormulaId, pastureId int64, pastureName, operationName, forageName, fieldName,
	beforeValue, afterValue string, status operationPb.FeedFormulaEditRecordType_Kind) *FeedFormulaEditRecord {
	return &FeedFormulaEditRecord{
		GroupId:       groupId,
		FeedFormulaId: feedFormulaId,
		PastureId:     pastureId,
		PastureName:   pastureName,
		OperationName: operationName,
		ForageName:    forageName,
		FieldName:     fieldName,
		Status:        status,
		BeforeValue:   beforeValue,
		AfterValue:    afterValue,
	}
}
