package model

type PastureDataLog struct {
	Id        int64  `json:"id"`
	LogType   int32  `json:"log_type"`
	PastureId int64  `json:"pasture_id"`
	Body      string `json:"body"`
	Url       string `json:"url"`
	Response  string `json:"response"`
	CreatedAt int64  `json:"created_at"`
	UpdatedAt int64  `json:"updated_at"`
}

func (p *PastureDataLog) TableName() string {
	return "pasture_data_log"
}

func NewPastureDataLog(pastureId int64, logType int32, url, body, response string) *PastureDataLog {
	return &PastureDataLog{
		LogType:   logType,
		PastureId: pastureId,
		Body:      body,
		Url:       url,
		Response:  response,
	}
}
